栏目分类:
子分类:
返回
名师互学网用户登录
快速导航关闭
当前搜索
当前分类
子分类
实用工具
热门搜索
名师互学网 > IT > 软件开发 > 后端开发 > C/C++/C#

HDU - 3749(点双连通,求点所属连通块)

C/C++/C# 更新时间: 发布时间: IT归档 最新发布 模块sitemap 名妆网 法律咨询 聚返吧 英语巴士网 伯小乐 网商动力

HDU - 3749(点双连通,求点所属连通块)

题目链接
一.题目内容

一堆废话,大概意思就是,给你一个无向无重边图,点从0到n-1,然后q次query,每次给两个点u,v,问以u为起点,v为终点,它们属于几条路径(要求:除了u和v,其它的点在所有路径中都只能出现一次)。

样例2解释:

4 4 2
0 1
0 2
1 2
2 3

1 2
1 3

1到2的路径 1->0->2,1->2 两条
1到3的路径 1->0->2->3,1->2->3 两条,但是题目要求除了起点和终点,其余的点只能出现1次,而在这里点2出现了两次,所以最后要舍去一条路径,答案为1条


二.解题思路

通过样例2我们可以看出,若u和v的路径之间包含了能分割它们的割点,那么它们的路径必经过该点,所以路径只有一条。而当x和y属于同一个点双连通分量时,如1和2,那么根据点双连通意义,它们之间肯定有两条甚至多条路径。

zero的情况:无路径,因为是无向图,做一遍并查集然后判断就行。
one的情况:有一条路径,两点之间不含能分割它们的割点,即两点不在一个点双连通分量里。
two or more的情况:有多条路径,即两点在同一个点双连通分量里。

三.解题代码
#include
using namespace std;
#define rep(i,l,r) for(int i=l;i<=r;++i)
#define rrep(i,l,r) for(int i=l;i>=r;--i)
#define out(x) cout<<(x)<
#define pb push_back
#define int long long
#define uint unsigned long long
const int N=1e4+10,mod=998244353;
/
int n,m,q;
vectora[N];
int uset[N];
int pos[N],low[N],cur;
int bcc[N],bccno;
unordered_mapbccmk[N];
stackvs;
void ini() {
    rep(i,0,n) {
        uset[i]=i;
        a[i].clear();
        bccmk[i].clear();
        pos[i]=low[i]=bcc[i]=0;
    }
    cur=bccno=0;
}
int fi(int x) {
    return uset[x]==x?x:uset[x]=fi(uset[x]);
}
void dfs(int x,int fa) {
    pos[x]=low[x]=++cur;
    vs.push(x);
    for(auto i:a[x]) {
        if(i==fa) continue;
        if(!pos[i]) {
            dfs(i,x);
            low[x]=min(low[x],low[i]);
            if(pos[x]==low[i]) {  //判断x是否为该连通块起点
                ++bccno;
                bccmk[x][bccno]=1; //x提前标记当前连通块,防止被pop掉
                while(1) {
                    int now=vs.top();
                    if(low[now]>n>>m>>q&&n+m+q) {
        ini();
        while(m--) {
            int x,y;
            cin>>x>>y;
            a[x].pb(y),a[y].pb(x);
            uset[fi(x)]=fi(y);   //并查集合并
        }
        rep(i,0,n-1) if(!pos[i]) dfs(i,-1);  
        cout<<"Case "<<++cnt<<":"<>x>>y;
            if(fi(x)!=fi(y)) {
                out("zero");
                continue;
            }
            int fg=0;
            for(auto i:bccmk[x]) {
                if(i.second!=1) continue;
                if(bccmk[y][i.first]==1) { //判断xy是否属于同一bcc
                    fg=1;
                    break;
                }
            }
            out(fg?"two or more":"one");
        }
    }
}

四.小结

似乎我对点双连通的理解有些问题,按它的定义来说,两个相连的点也应该算一个特殊的点双连通块,但是平常的tarjan代码都似乎只处理由三个或以上的点组成的连通块。本题我的思路一直都是按三个点来算,所以后面只要两个处于同一个连通块就会有两条及以上路径。看其他人的题解好像都是按两个来算的,似乎也更好理解一点。

转载请注明:文章转载自 www.mshxw.com
本文地址:https://www.mshxw.com/it/1033181.html
我们一直用心在做
关于我们 文章归档 网站地图 联系我们

版权所有 (c)2021-2022 MSHXW.COM

ICP备案号:晋ICP备2021003244-6号